unit M36u;

{
            M36
 Potreba : op.bmp
           sa.bmp
           no.bmp
           ko.bmp
           copy.bmp
           paste.bmp
           cut.bmp
           dict.txt
           M36.exe
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ImgList, ComCtrls, ToolWin, StdCtrls,clipbrd;

type
  TFM36 = class(TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Otevt1: TMenuItem;
    Uloit1: TMenuItem;
    Uloitjako1: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ImageList1: TImageList;
    Nov1: TMenuItem;
    ToolButton5: TToolButton;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    pravy1: TMenuItem;
    Kontrolapravopisu1: TMenuItem;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    N2: TMenuItem;
    Vloit1: TMenuItem;
    Koprovat1: TMenuItem;
    Vzjmout1: TMenuItem;
    StatusBar1: TStatusBar;
    N3: TMenuItem;
    Uloitslovnk1: TMenuItem;
    N4: TMenuItem;
    Nastaven1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Nov1Click(Sender: TObject);
    procedure Otevt1Click(Sender: TObject);
    procedure Uloitjako1Click(Sender: TObject);
    procedure Uloit1Click(Sender: TObject);
    procedure Kontrolapravopisu1Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure Uloitslovnk1Click(Sender: TObject);
    procedure Nastaven1Click(Sender: TObject);
  private
    { Private declarations }
    filenam:string;
    function pocSlov(a:string):integer;
    function Slovo(a:string;b:word):string;
    function porovnej(a:string):boolean;
  public
    { Public declarations }
    modul : integer;
    soubIn,dic : TStrings;

    procedure prik;
    procedure filtr;
  end;

var
  FM36: TFM36;

implementation

uses M36u1, M36u2;

{$R *.DFM}

const
  pocZn = 6;
  Zn : array[1..pocZn] of char = (' ',',','.',';','?',#9);

procedure TFM36.filtr;
var
  i,j:integer;
  sl:string;
begin
  for i:=0 to dic.count-1 do begin
    sl:=dic.strings[i];
    for j:=length(sl) downto 1 do begin
      if sl[j]='/' then sl:=copy(sl,1,j-1);
    end;
    dic.strings[i]:=sl;
  end;
end;


procedure TFM36.FormCreate(Sender: TObject);
begin
  modul:=255;
  dic:=TStringList.Create;
  soubIn:=TStringList.Create;
  try
    dic.LoadFromFile(ExtractFilePath(paramstr(0))+'dict.txt');
  except
    showMessage('Nemohu nalezt soubor se slovnikem');
    dic.Free;
    soubIn.Free;
    halt;
  end;
  filtr; {Odstrani nepotrebne ze slovniku}
  if paramcount<>0 then prik; {Prikazova radka}
end;

procedure TFM36.prik;
var
  i,j,k:integer;
  d,sl:string;
begin
  try
    soubIn.LoadFromFile(paramstr(1));
  except
    showMessage('Nemohu nalezt vstupni soubor.');
    dic.Free;
    soubIn.Free;
    Halt;
  end;
  for i:=0 to soubIn.Count-1 do
  for j:=1 to pocSlov(soubIn.strings[i]) do begin {Cyklus J}
    sl:=slovo(soubIn.Strings[i],j);
    if (not porovnej(sl)) and (sl<>'') then begin {Porovnej}
      k:=pos(sl,soubIn.Strings[i]); {pozice slova v retezci}
      d:=soubIn.Strings[i];
      Insert('#',d,k);
      soubIn.Strings[i]:='';
      soubIn.Strings[i]:=d;
    end; {Konec Porovnej}
  end; {Konec Cyklus}
  try
    soubIn.SaveToFile(paramStr(2));
  except
    showMessage('Soubor se nepodarilo ulozit.');
  end;
  dic.Free;
  soubIn.Free;
  Halt;
end;

function oddel(a:char):boolean;
var
  i:byte;
begin
  Result:=False;
  for i:=1 to pocZN do
    if a=Zn[i] then Result:=True;
end;

function TFM36.pocSlov(a:string):integer;
var
  c,i:integer; {pocet oddelovacu slov}
begin
  if length(a)<>0 then c:=1 else c:=0;
  for i:=1 to length(a) do begin
    if oddel(a[i]) then c:=c+1;
  end;
  Result:=c;
end;

function TFM36.Slovo(a:string;b:word):string;
var
  c,i:integer;
  d:string; {vybrane slovo z vety}
begin
  if length(a)<>0 then c:=1 else c:=0;
  for i:=1 to length(a) do begin
    if oddel(a[i]) then c:=c+1;
    if (c=b) and not oddel(a[i]) then d:=d+a[i];
  end;
  Result:=d;
end;

function TFM36.porovnej(a:string):boolean; {Porovna dva vyrazy}
var
  i:integer;
begin
  Result:=False;
  for i:=0 to dic.count-1 do
    if UpperCase(a)=UpperCase(dic.Strings[i]) then Result:=True;
  if FNastav.CheckBox1.Checked then {Je-li nastaveno}
  for i:=1 to length(a) do begin
    if (a[i]<='9') and (a[i]>='0') then Result:=True; {Preskoci slova s cislici}
  end;
  if FNastav.CheckBox2.Checked then {Je-li nastaveno}
  if length(a)=1 then Result:=True; {preskoci jednopis. slova}
end;


procedure TFM36.Konec1Click(Sender: TObject);
begin
  modul:=0;
  Close;
end;

procedure TFM36.Nov1Click(Sender: TObject);
begin
  Memo1.lines.Clear;
  FM36.caption:='M36';
end;

procedure TFM36.Otevt1Click(Sender: TObject);
begin
  if OpenDialog1.execute then begin
    try
      Memo1.lines.loadfromfile(OpenDialog1.FileName);
      filenam:=OpenDialog1.FileName;
      FM36.caption:='M36 - '+filenam;
    except
      ShowMessage('Nemohu otevt soubor '+Filenam);
    end;
  end;
end;

procedure TFM36.Uloitjako1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then begin
    Memo1.Lines.SaveToFile(SaveDialog1.FileName);
    filenam:=SaveDialog1.FileName;
    FM36.caption:='M36 - '+filenam;
  end;
end;

procedure TFM36.Uloit1Click(Sender: TObject);
begin
  Memo1.Lines.SaveToFile(Filenam);
end;

procedure TFM36.Kontrolapravopisu1Click(Sender: TObject);
var
  i,j,k:integer;
  sl,d:string;
  M, PosReturn, SkipChars: Integer;
begin
  modul:=255;
  FPrav.show;
  for i:=0 to Memo1.lines.Count-1 do
  for j:=1 to pocSlov(Memo1.lines.strings[i]) do begin {Cyklus J}
    sl:=slovo(Memo1.lines.Strings[i],j);
    if (not porovnej(sl)) and (sl<>'') then begin {Porovnej}
      k:=pos(sl,Memo1.lines.Strings[i]); {pozice slova v retezci}
      d:=Memo1.lines.Strings[i];
      PosReturn :=k;
      Skipchars := 0;
      for M := 0 to I - 1 do
        Skipchars := Skipchars + Length(Memo1.Lines[M]);
      SkipChars := SkipChars + (I*2);
      SkipChars := SkipChars + PosReturn - 1;
      Memo1.SetFocus;
      Memo1.SelStart := SkipChars;
      Memo1.SelLength := Length(sl);
      FPrav.Edit1.text:=Memo1.SelText; {slovo}
      FPrav.Edit2.text:=Memo1.SelText; {slovo}
      FPrav.Edit3.text:=d; {Okolni text}
      FPrav.Edite;
      FPrav.show;
      repeat
        Application.ProcessMessages;
      until modul<>255;
      case modul of
        0 : begin {Storno}
          FPrav.Hide;
          exit;
        end;
        2 : begin {Nahradit}
          Memo1.SelText:=FPrav.Edit2.text;
        end;
        3 : begin {Vymazat}
          Memo1.SelText:='';
        end;
        4 : begin {Nahradit ze slovniku}
          Memo1.SelText:=FPrav.CBox1.text;
        end;
      end;
      modul:=255;
    end; {Konec Porovnej}
  end; {Konec Cyklus}
  FPrav.Hide;
end;

procedure TFM36.ToolButton6Click(Sender: TObject);
begin
  ClipBoard.SetTextBuf(PChar(Memo1.seltext));
  Memo1.SelText:='';
end;

procedure TFM36.ToolButton7Click(Sender: TObject);
begin
  ClipBoard.SetTextBuf(PChar(Memo1.seltext));
end;

procedure TFM36.ToolButton8Click(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
end;

procedure TFM36.Uloitslovnk1Click(Sender: TObject);
begin
  FM36.dic.SaveToFile(ExtractFilePath(paramstr(0))+'dict.txt');
end;

procedure TFM36.Nastaven1Click(Sender: TObject);
begin
  FNastav.Showmodal;
end;

end.
